import request from '@/utils/request';
import type { ApiResult } from '@/api/index';
import type { AccessKey, AccessKeyParam } from './model';
import { PageResult } from '@/api/index';
import {SERVER_API_URL} from "@/utils/server";
/**
 * 查询AccessKey列表
 */
export async function pageAccessKey(params: AccessKeyParam) {
  const res = await request.get<ApiResult<PageResult<AccessKey>>>(
    SERVER_API_URL + '/system/access-key/page',
    { params }
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加AccessKey
 */
export async function addAccessKey(data: AccessKey) {
  const res = await request.post<ApiResult<unknown>>(
    SERVER_API_URL + '/system/access-key',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改AccessKey
 */
export async function updateAccessKey(data: AccessKey) {
  const res = await request.put<ApiResult<unknown>>(
    SERVER_API_URL + '/system/access-key',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除AccessKey
 */
export async function removeAccessKey(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    SERVER_API_URL + '/system/access-key/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}
